Atomic(T) - Crystal 1.5.1

# struct Atomic(T)

- Atomic(T)
- Struct
- Value
- Object

##
Overview

A value that may be updated atomically.

Only primitive integer types, reference types or nilable reference types can be used with an Atomic type.

##
Defined in:

atomic.cr

##
Constructors

- .new(value : T)

  Creates an Atomic with the given initial value.

##
Instance Method Summary

- #add(value : T) : T

  Performs `atomic_value += value`.

- #and(value : T) : T

  Performs `atomic_value &= value`.

- #compare_and_set(cmp : T, new : T) : Tuple(T, Bool)

  Compares this atomic's value with cmp:

- #get : T

  Atomically returns this atomic's value.

- #lazy_get

  Non-atomically returns this atomic's value.

- #lazy_set(value : T) : T

  Non-atomically sets this atomic's value to value.

- #max(value : T)

  Performs `atomic_value = max(atomic_value, value)`.

- #min(value : T)

  Performs `atomic_value = min(atomic_value, value)`.

- #nand(value : T) : T

  Performs `atomic_value = ~(atomic_value & value)`.

- #or(value : T) : T

  Performs `atomic_value |= value`.

- #set(value : T) : T

  Atomically sets this atomic's value to value.

- #sub(value : T) : T

  Performs `atomic_value -= value`.

- #swap(value : T)

  Atomically sets this atomic's value to value.

- #xor(value : T) : T

  Performs `atomic_value ^= value`.

### Instance methods inherited from struct `Struct`

==(other) : Bool ==, hash(hasher) hash, inspect(io : IO) : Nil inspect, pretty_print(pp) : Nil pretty_print, to_s(io : IO) : Nil to_s

### Instance methods inherited from struct `Value`

==(other : JSON::Any)
==(other : YAML::Any)
==(other) ==, dup dup

### Instance methods inherited from class `Object`

! : Bool !, !=(other) !=, !~(other) !~, ==(other) ==, ===(other : JSON::Any)
===(other : YAML::Any)
===(other) ===, =~(other) =~, as(type : Class) as, as?(type : Class) as?, class class, dup dup, hash(hasher)
hash hash, in?(collection : Object) : Bool
in?(*values : Object) : Bool in?, inspect(io : IO) : Nil
inspect : String inspect, is_a?(type : Class) : Bool is_a?, itself itself, nil? : Bool nil?, not_nil! not_nil!, pretty_inspect(width = 79, newline = "\n", indent = 0) : String pretty_inspect, pretty_print(pp : PrettyPrint) : Nil pretty_print, responds_to?(name : Symbol) : Bool responds_to?, tap(&) tap, to_json(io : IO) : Nil
to_json : String to_json, to_pretty_json(indent : String = " ") : String
to_pretty_json(io : IO, indent : String = " ") : Nil to_pretty_json, to_s(io : IO) : Nil
to_s : String to_s, to_yaml(io : IO) : Nil
to_yaml : String to_yaml, try(&) try, unsafe_as(type : T.class) forall T unsafe_as

### Class methods inherited from class `Object`

from_json(string_or_io, root : String)
from_json(string_or_io) from_json, from_yaml(string_or_io : String | IO) from_yaml

##
Constructor Detail

def self.new(value : T) #

Creates an Atomic with the given initial value.

##
Instance Method Detail

def add(value : T) : T #

Performs `atomic_value += value`. Returns the old value.

    atomic = Atomic.new(1)
    atomic.add(2) # => 1
    atomic.get    # => 3

def and(value : T) : T #

Performs `atomic_value &= value`. Returns the old value.

    atomic = Atomic.new(5)
    atomic.and(3) # => 5
    atomic.get    # => 1

def compare_and_set(cmp : T, new : T) : Tuple(T, Bool) #

Compares this atomic's value with cmp:

- if they are equal, sets the value to new, and returns `{old_value, true}`
- if they are not equal the value remains the same, and returns `{old_value, false}`

    atomic = Atomic.new(1)

    atomic.compare_and_set(2, 3) # => {1, false}
    atomic.get                   # => 1

    atomic.compare_and_set(1, 3) # => {1, true}
    atomic.get                   # => 3

def get : T #

Atomically returns this atomic's value.

def lazy_get #

Non-atomically returns this atomic's value.

def lazy_set(value : T) : T #

Non-atomically sets this atomic's value to value. Returns the new value.

    atomic = Atomic.new(5)
    atomic.lazy_set(10) # => 10
    atomic.get          # => 10

def max(value : T) #

Performs `atomic_value = max(atomic_value, value)`. Returns the old value.

    atomic = Atomic.new(5)

    atomic.max(3) # => 5
    atomic.get    # => 5

    atomic.max(10) # => 5
    atomic.get     # => 10

def min(value : T) #

Performs `atomic_value = min(atomic_value, value)`. Returns the old value.

    atomic = Atomic.new(5)

    atomic.min(10) # => 5
    atomic.get     # => 5

    atomic.min(3) # => 5
    atomic.get    # => 3

def nand(value : T) : T #

Performs `atomic_value = ~(atomic_value & value)`. Returns the old value.

    atomic = Atomic.new(5)
    atomic.nand(3) # => 5
    atomic.get     # => -2

def or(value : T) : T #

Performs `atomic_value |= value`. Returns the old value.

    atomic = Atomic.new(5)
    atomic.or(2) # => 5
    atomic.get   # => 7

def set(value : T) : T #

Atomically sets this atomic's value to value. Returns the new value.

    atomic = Atomic.new(5)
    atomic.set(10) # => 10
    atomic.get     # => 10

def sub(value : T) : T #

Performs `atomic_value -= value`. Returns the old value.

    atomic = Atomic.new(9)
    atomic.sub(2) # => 9
    atomic.get    # => 7

def swap(value : T) #

Atomically sets this atomic's value to value. Returns the old value.

    atomic = Atomic.new(5)
    atomic.swap(10) # => 5
    atomic.get      # => 10

def xor(value : T) : T #

Performs `atomic_value ^= value`. Returns the old value.

    atomic = Atomic.new(5)
    atomic.xor(3) # => 5
    atomic.get    # => 6